Communities

Writing
Writing
Codidact Meta
Codidact Meta
The Great Outdoors
The Great Outdoors
Photography & Video
Photography & Video
Scientific Speculation
Scientific Speculation
Cooking
Cooking
Electrical Engineering
Electrical Engineering
Judaism
Judaism
Languages & Linguistics
Languages & Linguistics
Software Development
Software Development
Mathematics
Mathematics
Christianity
Christianity
Code Golf
Code Golf
Music
Music
Physics
Physics
Linux Systems
Linux Systems
Power Users
Power Users
Tabletop RPGs
Tabletop RPGs
Community Proposals
Community Proposals
tag:snake search within a tag
answers:0 unanswered questions
user:xxxx search by author id
score:0.5 posts with 0.5+ score
"snake oil" exact phrase
votes:4 posts with 4+ votes
created:<1w created < 1 week ago
post_type:xxxx type of post
Search help
Notifications
Mark all as read See all your notifications »
Q&A

Comments on How to invert command exit code?

Parent

How to invert command exit code?

+3
−0

How to apply a logical not to a shell command, e.g. in a Bash script?

So if the command exited with 0 (success) I would like it to be changed to a non-zero value, and if it exited with a non-zero value (failure) like 1, I would like it to become 0. A negation of sorts.

History
Why does this post require moderator attention?
You might want to add some details to your flag.
Why should this post be closed?

0 comment threads

Post
+4
−0

An exclamation mark followed by space in the beginning of a pipeline will negate the final exit code of the pipeline.

Here's an example in Bash. Echoing $? will print out the exit code of the previous command (which is also an echo in this case).

$ echo OpenStreetMap is the best map
OpenStreetMap is the best map
$ echo $?
0
$ ! echo OpenStreetMap is meh
OpenStreetMap is meh
$ echo $?
1

This is a Posix thing.

History
Why does this post require moderator attention?
You might want to add some details to your flag.

1 comment thread

Why emphasize "final"? (3 comments)
Why emphasize "final"?
Karl Knechtel‭ wrote about 2 months ago

Are return codes for intermediate steps in the pipeline relevant and/or accessible in the first place?

Michael‭ wrote about 2 months ago

Makes sense to me. It could save some poor sod from thinking you could pipe to test like this:

false | test || echo 'False!'
! false | test && echo 'True!'

You're inverting the exit code of test, not inverting false as someone might imagine. (Is this contrived? Yes, very. Is it important? Maybe.)

Kamil Maciorowski‭ wrote about 1 month ago

Karl Knechtel‭ "accessible in the first place?" – In Bash there is ${PIPESTATUS[@]}, it is not affected by the ! the answer is about. You can think of $? as derived from ${PIPESTATUS[@]} according to pipefail (set -o | grep pipefail) and the presence (or not) of !.